// pt3md autospeed cruncher - by wbcbz7 zz.o5.zol7

#include "stdafx.h"
#include <vector>
#include <stdio.h>
#include <string.h>

#define max(a, b) ((a) > (b) ? (a) : (b))

const char vortex_pattern[] = "Vortex Tracker II v1.0 Pattern"; 

std::vector<int> inspd;		// input  data
std::vector<int> outspd;	// output data (control only)
std::vector<int> autospd;	// autospeed pattern
std::vector<int> mixspd;	// mixed  data for verifying

size_t empty = 0;			// num of empty lines

// fucking log2 >_<
int log2(int a) {
    int b = 0; while (a >>= 1) b++; return b;
}

// read speed data from file
bool rdspd(FILE *f) {
	char bf[256];

	// read first string
	fgets(bf, sizeof(char)*256, f);

	// check for vt2 pattern data ;)
	if (strncmp(bf, vortex_pattern, sizeof(vortex_pattern))) {
		// data in form "B.xx", xx - hex speed

		while (!feof(f)) {
			fgets(bf, sizeof(char)*256, f);
			char *b = strstr(bf, "B");

			if (b) {
				if (*(b+2) = '.') *(b+2) = '0'; // fix
				
				int val = 0;
				sscanf_s((b+2), "%2x", &val);
				inspd.push_back(val);
			} else {
				inspd.push_back(0);
				empty++;
			}
		}

	} else return true;

	inspd.pop_back(); //   
	return false;
}

// find most fitting pattern
std::vector<int> findpattern() {

	struct en {
		std::vector<int> d;
		size_t pen;				// penalty count
	};

	std::vector<en> pat;

	// slow slow slow and a bit buggy algo

	for (size_t a = (inspd.size() / 2); a > 0; a--) {
		en v;
		v.d.resize(a);

		std::vector<int>::iterator head = inspd.begin(), tail = inspd.begin() + a;
		std::copy(head, tail, v.d.begin());

		v.pen = 0;
		
		// display pattern
		wprintf(L"--------\n");
		wprintf(L"patlen = %d\n", v.d.size());
		wprintf(L"data: ");
		for (size_t i = 0; i < v.d.size(); i++) wprintf(L"%d,", v.d.at(i));
		wprintf(L"\n");

		// do penalty count
		for (size_t i = 0; i < inspd.size(); i++) if (v.d.at(i % v.d.size()) != inspd.at(i)) v.pen++;
		wprintf(L"%d penalties\n", v.pen);

		pat.push_back(v);
	}

	// find most suitable pattern
	std::vector<en>::iterator kewl = pat.end()-1;
	for (std::vector<en>::iterator it = pat.end()-1; it > pat.begin(); it--) {
		if ((it->pen < kewl->pen) && (it->d.size() <= (max((inspd.size() / 16), 1)*kewl->d.size()))) kewl = it;
	}

	// display most suitable pattern
		wprintf(L"-----most suitable pattern----------\n");
		wprintf(L"patlen = %d\n", kewl->d.size());
		wprintf(L"data: ");
		for (size_t i = 0; i < kewl->d.size(); i++) wprintf(L"%d,", kewl->d.at(i));
		wprintf(L"\n");


	if ((kewl->d.size() * 3) < inspd.size()) return kewl->d; else {
		// if pattern is useless - return empty pattern
		wprintf(L"useless - return empty pattern");
		std::vector<int> r;
		return r;
	}
}

// optimize according by given autospeed pattern
bool optimize(std::vector<int> spd) {
	if (spd.size() <= 1) {
		// copy src pattern
		mixspd.resize(inspd.size());
		std::copy(inspd.begin(), inspd.end(), mixspd.begin());
		return false;
	};
	bool nasd = false;	// don't use autospeed
	bool rasd = true;	// repeat autospd
	int  nacc = 0;


	for (size_t i = 0; i < inspd.size(); i++) {
		if (inspd[i] == spd[i % spd.size()]) {
			if (rasd) mixspd.push_back(0); else mixspd.push_back(-1);
			rasd = true;
		} else  {
			rasd = false;
			if (inspd[i]) {
				mixspd.push_back(inspd[i]);
				nacc = inspd[i];
			} else {
				size_t k = i;
				while ((k >= 0) && (!inspd[k])) k--;
				if (inspd[k] == nacc) mixspd.push_back(0); else {
					nacc = inspd[k];
					mixspd.push_back(inspd[k]);
				}
			}
		}
	}

	return false;
}

int _tmain(int argc, _TCHAR* argv[])
{
	if (argc < 2) {
		fwprintf(stderr, L"usage: autospd [infile.txt]\n");
		return 1;
	}

	_TCHAR infile[256];
	FILE *f;
	wcscpy_s(infile, 256, argv[1]);
	
	_wfopen_s(&f, infile, L"r");
	if (!f) {
		fwprintf(stderr, L"error opening file %ls: ", infile); perror(0);
		return 1;
	}

	inspd.clear();

	// read from file
	if (rdspd(f)) {
		fwprintf(stderr, L"error reading from file %ls", infile);
		return 1;
	}

	// print source pattern
	wprintf(L"source speed pattern: length = %d\n", inspd.size());
	wprintf(L"-----------\n");
	for (size_t i = 0; i < inspd.size(); i++) {
		wprintf(L"0x%02X: ", i);
		if (inspd[i]) wprintf(L"B.%02X\n", inspd[i]); else wprintf(L"....\n"); 
	}
	wprintf(L"------------------------\n");

	optimize(findpattern());

	// print source pattern
	wprintf(L"dest speed pattern: length = %d\n", inspd.size());
	wprintf(L"-----------\n");
	for (size_t i = 0; i < mixspd.size(); i++) {
		wprintf(L"0x%02X: ", i);
		if (mixspd[i]) if (mixspd[i] != -1) wprintf(L"B.%02X\n", mixspd[i]); else wprintf(L"B.00\n"); else wprintf(L"....\n"); 
	}
	wprintf(L"------------------------\n");

	return 0;
}

