#include "stdafx.h"
#include "plrint.h"

// make volume table
void make_voltab() {
	unsigned int *p = &voltab[0];

	for (size_t j = 0; j < 16; j++) {
		for (size_t i = 0; i < 16; i++) {
			*p++ = ((i * j) + 7) / 15;
		}
	}
}

// decrunch note table
void unpack_notetab(unsigned int dst[], u16 src[]) {
	for (size_t j = 0; j < NOTES; j++) {
		// unpack first octave
		dst[j] = src[j];

		// unpack other octaves
		for (size_t i = 1; i < OCTAVES; i++) {
			//    ,  
			dst[(i * NOTES) + j] = (src[j] >> i) + ((src[j] >> (i - 1)) & 1);
			//   (   (    %))
			//dst[(i * NOTES) + j] = (src[j] >> i);
		}
	}
}

bool _init(void *data) {
	pmdstream = (u8*)data;

	// check file format
	pmdhdr = (pt3md_hdr*)pmdstream;
	pmdmdl = (pt3md_mdl_hdr*)&pmdstream[sizeof(pt3md_hdr)];

	if (strncmp((const char*)pmdhdr->sign, "PMD\x1A", 4)) {
		fwprintf(stderr, L"incorrect file format!\n");
		return false;
	}
	// init
	unpack_notetab(notetab, (u16*)&pmdstream[pmdmdl->p_notetab]);
	make_voltab();

	player.pattab = (u8*)&pmdstream[pmdmdl->p_pattab];
	player.ordtab = (u8*)&pmdstream[pmdmdl->p_order];

	player.instab = (u16*)&pmdstream[pmdmdl->p_instab];
	player.orntab = (u16*)&pmdstream[pmdmdl->p_orntab];

	player.speed = player.spdpos = pmdmdl->speed;

	// set default channel vars 
	for (size_t i = 0; i < 4; i++) { 
		chan[i].globmixer.tone = chan[i].globmixer.noise = chan[i].globmixer.env = 1;
		chan[i].volume_ch = 15;
		chan[i].env = chan[i].basenote = chan[i].oldnote = 0;
		chan[i].cut = true;

		ins_set(i, 1, 0);
		orn_set(i, 0, 0);
	}
	chan[3].basenote = chan[3].oldnote = -1; 

	env_chan.noise.base = env_chan.noise.acc = env_chan.env.type = env_chan.env.base = 0; env_chan.env.restart = false;

	// set start pattern
	player.pattern.ordpos = player.pattern.pos =  0;
	pat_set(player.ordtab[player.pattern.ordpos]);

	player.spdpos++;		//       
	return true;
}