#include "stdafx.h"
#include "plrint.h"

// PSG stream
std::vector<u8> psgstream;

// PMD stream
u8 *pmdstream;

// note table
unsigned int notetab[NOTES * OCTAVES] = {0};

// volume table
unsigned int voltab[16*16] = {0};

// raw AY registers
ayregs_t ayregs[256] = {0};

// channel processing data
chan_t chan[4] = {0};
env_chan_t env_chan = {0};

// player vars
player_t player = {0};

pt3md_hdr		*pmdhdr;
pt3md_mdl_hdr	*pmdmdl;

bool _module_end = false;

void _play() {
	if (!(--player.spdpos)) pat_process();
	
	env_chan.noise.acc = env_chan.env.acc = 0;	// to prevent noise rollovers

	for (int i = 0; i < 3; i++) {
		if (!chan[i].cut) {

			//cmd_process(i);
			orn_process(i);
			ins_process(i);

			//      AY
			chan[i].tone.base  = notetab[chan[i].note];
			chan[i].tone.final = chan[i].tone.base + chan[i].tone.ins + chan[i].cmd.slide.acc;

			cmd_process(i);

			//chan[i].mixer.val &= chan[i].globmixer.val;

			u8 s;
			s = chan[i].tone.final & 0xFF; if (s != ayregs[(i<<1)  ].val) write_ay((i<<1), s);
			s = chan[i].tone.final >> 8;   if (s != ayregs[(i<<1)+1].val) write_ay((i<<1)+1, s);

			s = chan[i].volume | (chan[i].mixer.env << 4);
			if (chan[i].off) s = 0;
			if (s != ayregs[i+8].val) write_ay(i+8, s);
		} else {
			// nothing to play
			chan[i].mixer.tone = chan[i].mixer.noise = 1; chan[i].mixer.env = chan[i].volume = 0;
			if (ayregs[i+8].val != 0) write_ay(i+8, 0);
		}
	}

	// 
	u8 s;

	// pack noise
	env_chan.noise.final = env_chan.noise.acc + env_chan.noise.base;
	s = env_chan.noise.final & 0x1F; if (s != ayregs[6].val) write_ay(6, s);

	// pack mixer
	s = ((chan[0].mixer.tone)       | (chan[1].mixer.tone  << 1) | (chan[2].mixer.tone  << 2) |
		 (chan[0].mixer.noise << 3) | (chan[1].mixer.noise << 4) | (chan[2].mixer.noise << 5));

	if (s != ayregs[7].val) write_ay(7, s);

	cmd_process(3);

	// pack env period
	if (chan[3].basenote != -1) {
		// env as note
		orn_process(3);
		env_chan.env.base = notetab[chan[3].note];
	}
	env_chan.env.final = env_chan.env.base + env_chan.env.acc + chan[3].cmd.slide.acc;
	s = (env_chan.env.final     ) & 0xFF; if (s != ayregs[11].val) write_ay(11, s);
	s = (env_chan.env.final >> 8) & 0xFF; if (s != ayregs[12].val) write_ay(12, s);

	// write env type
	if (env_chan.env.restart) {write_ay(13, env_chan.env.type); env_chan.env.restart = false;}

	push_ay();
}
