
#include "stdafx.h"
#include "player.h"

#define PT3MD_VER_MAJOR 0
#define PT3MD_VER_MINOR 3

static unsigned char PSG_SIGN[] = {
	'P', 'S', 'G', 0x1A, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFF
};

#define max(a, b)		(a > b ? a : b)
#define min(a, b)		(a < b ? a : b)
#define clamp(a, l, h)	(a > h ? h : (a < l : l : a))

// pmd buffer
unsigned char	*pmdbuf;

FILE			*pmd;
FILE			*psg;
_TCHAR			pmdname[256], psgname[256];

size_t frames = 0;

int _tmain(int argc, _TCHAR* argv[])
{
	size_t parm_arg;
	
	wprintf(L"pt3md -> PSG converter - by wbcbz7 12.o2.zol7\n");

    if (argc < 2) {
		fwprintf(stderr, L"usage: pmd2psg [filename.pmd] <filename.psg> <arg>...\n");
		return 1;
	}
	
	wcscpy_s(pmdname, 256, argv[1]);

    if ((argc < 3) || (!wcsstr(argv[2], L"."))) {
        _TCHAR *pp = wcsstr(argv[1], L".");
        wcsncpy_s(psgname, 256, argv[1], (size_t)(pp - argv[1]));
        wcscat_s(psgname, 256, L".psg");
        parm_arg = 2;
    } else {
        wcscpy_s(psgname, 256, argv[2]);
        parm_arg = 3;
    }

	_wfopen_s(&pmd, pmdname, L"rb");
	if (!pmd) {
		fwprintf(stderr, L"error opening file %ls: ", pmd); perror(0);
		return 1;
	}

	// get filesize
	fseek(pmd, 0, SEEK_END);
	size_t pmd_fsize = ftell(pmd);

	// allocate maximum memory (also sandbox for broken modules)
	pmdbuf = new unsigned char[max(65536, pmd_fsize)];
	memset(pmdbuf, 0, sizeof(unsigned char) * max(65536, pmd_fsize));

	// read all file at once
	fseek(pmd, 0, SEEK_SET);
	fread(pmdbuf, sizeof(unsigned char) * pmd_fsize, 1, pmd);

	if (ferror(pmd)) {
		fwprintf(stderr, L"error reading file %ls: ", pmdname); perror(0);
		delete[] pmdbuf;
		return 1;
	}

	fclose(pmd);

	// init 
	if (!_init(pmdbuf)) {
		fwprintf(stderr, L"error: can't init\n");
		delete[] pmdbuf;
		return 1;
	}

	// main loop
	while (!_module_end) {_play(); frames++;}

	// write psg
	_wfopen_s(&psg, psgname, L"wb");
	if (!psg) {
		fwprintf(stderr, L"error opening file %ls: ", psg); perror(0);
		return 1;
	}

	// AY-Emul fix
	//psgstream.push_back(0xFD);
	fwrite(PSG_SIGN, sizeof(PSG_SIGN), 1, psg);
	fwrite(psgstream.data(), psgstream.size(), 1, psg);

	if (ferror(psg)) {
		fwprintf(stderr, L"error writing file %ls: ", psgname); perror(0);
		return 1;
	}

	wprintf(L"outfile -> %ls - %d frames\n", psgname, frames);
	wprintf(L"done\n");

	fclose(psg);

	return 0;
}

